#!/usr/bin/perl
#--NetShopOwner-CGI-version:4.2.5.5--

;#
;# order3.cgi
;# [PC]
;# Copyright (c) 2004- Increment P Corp. All rights reserved.
;#
;# 2009/09/30 NSO4Ή
;# last modified 2010/04/22 T.Hinohara SBPSϑΉ
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use Lib::SiteStatus;
use Design::TemplOrder3;
use Lib::ExpensesGoods;
use DB::NsoOrderTempDB;

&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# CX^X`
my $objConfigSystem  = Config::NsoSystem->newShop();
my $objConfigMaster  = Config::NsoMaster->new();
my $NsoMisc          = NsoMisc->new();
my $ExpensesGoods;
my $SamePeriodID    = "";	# ID
my $PossessionPoint = 0;	# ۗL|Cg
my $PointExpireDate = "";	# |CgL
# 2010/04/22 T.Hinohara start
my $LoginSessionID  = "";	# LoginSessionID
# 2010/04/22 T.Hinohara end

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $status_err;

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
	);
	
	&check_order_finish;
	&check_member_order();
	&check_request_method();
	&check_http_referer();
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}
exit();

;#
;# NGXg\bh
;#
sub check_request_method {
	unless ($ENV{REQUEST_METHOD} eq 'POST'){
		my $order1URL = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{order1};
		my $queryString = ( $SamePeriodID ne "" )?
		                    $NsoMisc->make_query_string({ func=>'logged_in' }, 'get'): '';
		print $NsoMisc->redirect( join("", $NsoMisc->getChangedURL({url=>$order1URL, key=>'AfterCart'}), $queryString) );
		exit();
	}
}

;#
;# HTTP_REFERER
;#
sub check_http_referer {
	return if( !$ConfigSystem{Default}{Referer}{Check} );
	my $cgiroot =  $NsoMisc->getChangedURL({url=>$ConfigSystem{base_href}{cgishop}, key=>'AfterCart'});
	my $order1URL = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{order1};
	
	unless ($ENV{HTTP_REFERER} =~ /$cgiroot/i){
		my $queryString = ( $SamePeriodID ne "" )?
		                    $NsoMisc->make_query_string({ func=>'logged_in' }, 'get'): '';
		print $NsoMisc->redirect( join("", $NsoMisc->getChangedURL({url=>$order1URL, key=>'AfterCart'}), $queryString) );
		exit();
	}
}

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing();
}

;#
;# C
;#
sub main {
	# e|[h
	my %RecOrderTemp = ();
	my $OrderTempRecordCount;
	OrderTemp:{
		my %where = ( OrderTempID=>1 );
		my $OrderTempDB   = NsoOrderTempDB->new();
		$OrderTempDB->load_data_no_lock({ where=>\%where });
		my %OrderTempHash = (
			FieldList   => $OrderTempDB->{FieldList},
			RecordList  => $OrderTempDB->{RecordList},
			RecordCount => $OrderTempDB->{RecordCount},
		);
		# R[h̃JEgێ
		$OrderTempRecordCount = $OrderTempHash{RecordCount};
		if ($OrderTempHash{RecordCount} > 0){
			my @OrderTempList = @{$OrderTempHash{RecordList}};
			%RecOrderTemp = %{$OrderTempList[0]};
		}
		# 2010/04/22 T.Hinohara start
		# Cookie̗LXV
		$OrderTempDB->update_expiration_cookie();
		# DBXV(ŏIXVύX̂)
		$OrderTempDB->update_no_lock();
		# 2010/04/22 T.Hinohara end
	};
	
	# s{ID
	my $StateID = ($RecOrderTemp{DeliveryFlag}) ? $RecOrderTemp{OrderPersonStateID} : $RecOrderTemp{OrderDeliveryStateID};
	
	# oZ
	my $isMember = ( $SamePeriodID eq "" )? 0: 1;
	my $ExpensesGoods = Lib::ExpensesGoods->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, StateID=>$StateID, PaymentClassID=>$RecOrderTemp{PaymentClassID},
                                                  IsMember=>$isMember, 					# tO
                                                  PossessionPoint=>$PossessionPoint,	# ۗL|Cg
                                                  PointExpireDate=>$PointExpireDate });	# |CgL
	
	# VXeev[gNXCX^X
	# 2010/04/22 T.Hinohara start
	#my $TemplOrder3  = Design::TemplOrder3->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, KickBack=>$in{KickBack}, ExpensesGoods=>$ExpensesGoods, status_err=>$status_err, Query=>\%RecOrderTemp, OrderTempRecordCount=>$OrderTempRecordCount, SamePeriodID=>$SamePeriodID });
	my $TemplOrder3  = Design::TemplOrder3->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, KickBack=>$in{KickBack}, ExpensesGoods=>$ExpensesGoods, status_err=>$status_err, Query=>\%RecOrderTemp, OrderTempRecordCount=>$OrderTempRecordCount, SamePeriodID=>$SamePeriodID, LoginSessionID=>$LoginSessionID });
	# 2010/04/22 T.Hinohara end

	# ue
	my $contents = $TemplOrder3->RelpaceSystemTempl();
	
	# VXeev[gu
	print $NsoMisc->print_header();
	print $contents;
	exit();
}

;#
;# iPCOSS`FbN
;#
sub check_order_finish {

	# IDNbL[ǂݎ
	require DB::NsoOrderIDDB;
	my $OrderIdDB = NsoOrderIDDB->new();
	my $OrderID   = $OrderIdDB->Read_OrderID();

	# IDNbL[cĂꍇ
	if ($OrderID ne ""){
		require Lib::IpcossCheck;
		my $IpcossCheck = Lib::IpcossCheck->new( {ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, ExpensesGoods=>$ExpensesGoods} );
		# ipcoss ChecksB
		my $IpcCheckFlag = $IpcossCheck->check_ipcoss();
		# okng̏ꍇ̏
		if ($IpcCheckFlag eq 0){
			# ngƂ̏
			$IpcossCheck->ipcoss_ng();
		} else {
			# ok Ƃ̏
			my $contents = $IpcossCheck->RelpaceSystemTempl();
			print $NsoMisc->print_header();
			print $contents;
			exit ();
		}
	}
}

;#
;# w
;#
sub check_member_order {
	my $orderSamePeriodID = "";
	my $loginSamePeriodID = "";

	# 擾
	my %where = ( OrderTempID=>1 );
	my $OrderTempDB = NsoOrderTempDB->new();
	$OrderTempDB->load_data_no_lock({ where=>\%where });

	# 2010/04/22 T.Hinohara start
	# Cookie̗LXV
	$OrderTempDB->update_expiration_cookie();
	# DBXV(ŏIXVύX̂)
	$OrderTempDB->update_no_lock();
	# 2010/04/22 T.Hinohara end

	# 񂪑݂ȂꍇAJ[gʂ
	if ( $OrderTempDB->{RecordCount} == 0 ) {
		&redirectBasketUrl({ ErrorStatus=>'no_orderTemp' });
	}
	
	my @arrOrderTemp = @{$OrderTempDB->{RecordList}};
	my %recOrderTemp = %{$arrOrderTemp[0]};
	$orderSamePeriodID = $recOrderTemp{SamePeriodID};
	
	if ( $orderSamePeriodID eq "" ) {	# ID݂Ȃꍇ
	
		# @\gpL/ݒ擾
		my $memberUseFlag      = $ConfigMaster{adm_member_master}{member}{UseFlag};
		my $memberSubscription = $ConfigMaster{adm_member_master}{member}{Subscription};

		# @\gp  ̂ݍw\ȏꍇAJ[gʂ
		if ( $memberUseFlag == 1 and $memberSubscription == 1 ) {
			&redirectBasketUrl({ ErrorStatus=>'only_member_service' });
		}
	} else {	# ID݂ꍇ
	
		# @\gpL擾
		my $memberUseFlag = $ConfigMaster{adm_member_master}{member}{UseFlag};

		# @\gp̏ꍇAJ[gʂ
		if ( $memberUseFlag == 0 ) {
			&redirectBasketUrl({ ErrorStatus=>'no_member_service' });
		}
		
		# OC擾
		require DB::NsoLoginTempDB;
		my %where = ( LoginTempID=>1 );
		my $LoginTempDB = NsoLoginTempDB->new();
		$LoginTempDB->load_data_no_lock({ where=>\%where });
		
		# OC񂪑݂ȂꍇAJ[gʂ
		if ( $LoginTempDB->{RecordCount} == 0 ) {
			&redirectBasketUrl({ ErrorStatus=>'logged_in' });
		}
		
		my @arrLoginTemp = @{$LoginTempDB->{RecordList}};
		my %recLoginTemp = %{$arrLoginTemp[0]};
		$loginSamePeriodID = $recLoginTemp{SamePeriodID};
		
		# ƃOC̓IDقȂꍇAJ[gʂ
		if ( $orderSamePeriodID ne $loginSamePeriodID ) {
			&redirectBasketUrl({ ErrorStatus=>'same_period_id_error' });
		}
		
		# 擾 (SamePeriodID)
		require DB::NsoMemberDB;
		my $MemberDB = NsoMemberDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
		if ( $MemberDB->{resultDbConnect} ne "" ) {
			&redirectBasketUrl({ ErrorStatus=>'db_access_error101' });
		}
		my %resultMemberDB = $MemberDB->Member_Select_ID_Query({ SamePeriodID=>$loginSamePeriodID });
		if ( $resultMemberDB{status_err} ne "" ) {
			&redirectBasketUrl({ ErrorStatus=>'db_access_error102' });
		}
		
		# 񂪎擾łȂꍇAJ[gʂ
		if ( $resultMemberDB{RecordCount} == 0 ) {
			&redirectBasketUrl({ ErrorStatus=>'logged_in_error' });
		}
		my %recMember = %{$resultMemberDB{RecordList}};
		
		# 敪F҂̏ꍇAJ[gʂ
		unless ( $recMember{MemberFlag} == 3 ) {	## MemberFlag
			&redirectBasketUrl({ ErrorStatus=>'logged_in_no_approval_member' });
		}
		
		# OCXV(ŏIXVύX̂)
		$LoginTempDB->update_no_lock(\%recLoginTemp);
		
		# Cookie̗LXV
		$LoginTempDB->update_expiration_cookie();
		
		# IDێ
		$SamePeriodID = $loginSamePeriodID;
		# ۗL|Cgێ
		$PossessionPoint = $recMember{Point};
		# |CgLێ
		$PointExpireDate = $recMember{PointExpireDate};
		# 2010/04/22 T.Hinohara start
		# LoginSessionIDێ
		$LoginSessionID = $LoginTempDB->LoginTempID();
		# 2010/04/22 T.Hinohara end
	}
}

;#
;# J[gʂփ_CNg
;#
sub redirectBasketUrl {
	my ($queryHash) = shift if @_;
	
	# J[gʃy[WURL
	my $basketUrl = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{basket};
	# SSL󋵂ɉURLu
	$basketUrl = $NsoMisc->getChangedURL({url=>$basketUrl, key=>'AfterCart'});

	my $queryString = $NsoMisc->make_query_string($queryHash, 'get');

	print $NsoMisc->redirect(join("", $basketUrl, $queryString));
	exit();
}












